#!/bin/env python
import xml.sax
import xml.sax.handler
import sys, os


def cas(Cas):
    #prevede cas na minuty
  try:
    if Cas[2]==':':
        h=int(Cas[0]+Cas[1])
        min=int(Cas[3]+Cas[4])
    else:
        h=int(Cas[0]+Cas[1])
        min=int(Cas[2]+Cas[3])
    return (h*60)+min
  except:
    return -1

def diff(t1, t2):
    #rozdil casu v minutach
    return abs(t1-t2)

def uncas(Cas):
    min=int(Cas)%60
    h=Cas-min
    min=str(min)
    h=str(h)
    if len(h)==1:
        h='0'+h
    if len(min)==1:
        min='0'+min
    return h+':'+min

cLinka=""
#aktualni linka pri parsovani XML

#aktualni stanice pri parsovani XML
Linky={}
#linky - asociativni pole
SeznamStanic=[]
#pole stanic
cNazev=""
#aktualni nazev stanice
#cas ve formatu poctu minut od posledni pulnoci
cPrijezd=0
cOdjezd=0

class Stanice:
    def __init__(self, nazev, prijezd, odjezd):
        self.nazev=nazev
        self.prijezd=prijezd
        self.odjezd=odjezd

class Linka: 
    def __init__(self,cislo):
        self.cislo=cislo
        self.stanice=[]
        self.poznamky=[]
    def nastup(self):
        return self.stanice[0]
    def vystup(self):
        return self.stanice[-1]
        

class MyHandler(xml.sax.handler.ContentHandler):
    def startElement(self,name,attr):
        global cLinka
        global cStanice
        global SeznamStanic
        global Linky
        global cNazev
        global cPrijezd
        global cOdjezd
        f={}
        for a in attr.keys():
            f[a]=attr[a]
        
        if name=="Linka":
            cLinka=f["cislo"]
            cStanice=""
            Linky[f["cislo"]]=Linka(f["cislo"])
            #vytvori linku
            #print "Linka "+cLinka #zdrzuje
        elif name=="Stanice":
            
            cOdjezd=f.get('odjezd', -1)
            cPrijezd=f.get('prijezd', cOdjezd)
            cNazev=''
        elif name=='Poznamka':
            cNazev=''
    def endElement(self,name):
        global cLinka
        global cStanice
        global SeznamStanic
        global Linky
        global cNazev
        global cPrijezd
        global cOdjezd
        if name=="Linka":
            cLinka=""
            cNazev=''
            cPrijezd=''
            cOdjezd=''
        elif name=="Stanice":
            stan=Stanice(cNazev, cas(cPrijezd), cas(cOdjezd))
            if not (cNazev in SeznamStanic):
                SeznamStanic.append(cNazev)
            Linky[cLinka].stanice.append(stan)
            cNazev=''
            cPrijezd=''
            cOdjezd=''
        elif name=="Poznamka":
            Linky[cLinka].poznamky.append(cNazev)
            cNazev=''
    def characters(self,data):
        global cLinka
        global cStanice
        global SeznamStanic
        global Linky
        global cNazev
        global cPrijezd
        global cOdjezd
        cNazev=cNazev+data


hand=MyHandler()

try:
    fn=sys.argv[1]
except:
    fn='data.xml'

try:
    port=int(sys.argv[2])
except:
    port=80

print "Parsuji XML . . ."
    
xml.sax.parse(fn,hand)
#nazev datasouboru - 1. parametr nebo data.xml 

###########################TELO PROGRAMU###################################

def cmdStanice():
    res='<SeznamStanic>\r\n'
    global SeznamStanic
    for st in SeznamStanic:
        res=res+'  <Stanice>'+st+'</Stanice>\r\n'
    res=res+'</SeznamStanic>\r\n'
    return res

def vyresit(kam,linka, level,trek):
    global Linky
    mytrek=trek
    
    mytrek.append(linka)
    if linka.vystup().nazev==kam:
        return [mytrek]
    if level>1:
        for i in Linky.keys():
            if Linky[i].nastup().nazev==linka.vystup().nazev:
                for j in vyresit(kam, i, level-1, mytrek):
                    ok=0
                    for rr in j:
                        for rr2 in rr:
                            if pres in rr2:
                                ok=1
                    if ok==1:
                        reseni.append(j)
                


def cmdLinky(args):
    global Linky
    odkud=args['odkud']
    kam=args['kam']
    pres=args['pres']
    prestupy=args['prestupy']
    spojeni=args['spojeni']
    reseni=[]
    for i in Linky.keys():
        if Linky[i].nastup().nazev==odkud:
            for j in vyresit(kam,Linky[i], prestupy, []):
                for rr in j:
                    ok=0
                    for rr in j:
                        for rr2 in rr:
                            if pres in rr2:
                                ok=1
                    if ok==1:
                        reseni.append(j)                  
                   
    r=''
    for rrr in reseni:
        
            



    

##########################OBSLUHA HTTP#######################################

print "Inicializuji serverove sluzby . . ."

import SocketServer
from SimpleHTTPServer import SimpleHTTPRequestHandler
from BaseHTTPServer import HTTPServer
from StringIO import StringIO
import urllib,posixpath

def obsluha(pozadavek):
  print 'Obsluha ' + pozadavek
    
   
  try:
    r=''
    cmd=pozadavek[0:13]
    if cmd=='/SeznamStanic':
      r=cmdStanice()  
    elif cmd=='/NajdiSpojeni':
        cmd,arg=pozadavek.split("?")
        #oddelit parametry

        arg=arg.split('&')
        for a in arg:
            aa=a.split('=')
            args[aa[0]]=aa[1]
        del a
        del aa
        del arg
  
        r=cmdLinky(args)
    else:
        r='<Chyba>Neplatny prikaz. Zkuste /SeznamStanic nebo /NajdiSpojeni</Chyba>'
    return r
  except:
    raise
    return '<Chyba>Interni chyba serveru</Chyba>'



class MyHTTP(SimpleHTTPRequestHandler):
    def guess_type(self, path):
        return "text/xml"
    def send_head(self):
        path = self.path
        f = None
        #[path.find('GET "')+1:path.rfind('"')+1]
        path = posixpath.normpath(urllib.unquote(path))
        words = path.split('/')
        words = filter(None, words)
        path = '/'
        for word in words:
            drive, word = os.path.splitdrive(word)
            head, word = os.path.split(word)
            if word in (os.curdir, os.pardir): continue
            path = os.path.join(path, word)
        
        #uprava cesty
        
        ctype = self.guess_type(path)


        
        res=obsluha(path)
        f = StringIO(res)
        self.send_response(200)
        self.send_header("Content-type", ctype)
        self.send_header("Content-Length", str(len(res)))
        self.end_headers()
        return f
try:    

    server_address = ('', port)

    MyHTTP.protocol_version = "HTTP/1.0" #HTTP 1.0
    httpd = HTTPServer(server_address, MyHTTP) #server
    sa = httpd.socket.getsockname()
except:
    print('Pro spusteni na portu nizsim nez 1024 musite byt root')
    sys.exit(3)
    
print "Obsluha na ", sa[0], ", port ", sa[1], "..."
httpd.serve_forever() #start serveru


